//Main application - variable setup
#include <SPI.h>
#include <Ethernet.h>
#include <utility/w5100.h&ht;
#include "Pond_Monitor_struct.h"

byte mac[] = { 0x00, 0xAA, 0xBB, 0xCC, 0xDE, 0x02 };
IPAddress ip(192,168,1, 177);

IPAddress server(127, 0, 0, 1);

EthernetClient client;
String data;
char tmp[10];




//Main application - setup()
void setup() {
  Serial.begin(9600);
  if (Ethernet.begin(mac) == 0) {
    Serial.println("Failed to configure Ethernet using DHCP");
    // DHCP failed, so use a fixed IP address:
    Ethernet.begin(mac, ip);
  }
  Serial.println("connecting...");
  W5100.setRetransmissionTime(0x2710);
  W5100.setRetransmissionCount(3);
}




//Main application - loop()
void loop() {
  //Test/debugging code
  Pond_MonitorPost_t holder;
  holder.field_temp = millis() % 128;
  holder.field_humidity = millis() % 128;
  holder.field_light = millis() % 128;
  drupal_post_Pond_Monitor(holder);
  delay(2000);
}




//Main application - new functions
void drupal_post_Pond_Monitor(Pond_MonitorPost_t Pond_MonitorPost) {
  data = "";
  data += "token=";
  data += DRUPAL_API_KEY_POND_MONITOR;
  data += "&millis=";
  data += millis();
  data += "&rtc=";
  data += "&mac=";
  data += "&localip=";
  data += Ethernet.localIP();
  dtostrf(Pond_MonitorPost.field_temp,1,2,tmp);
  data += "&field_temp=";
  data += tmp;
  dtostrf(Pond_MonitorPost.field_humidity,1,2,tmp);
  data += "&field_humidity=";
  data += tmp;
  data += "&field_light=";
  data += Pond_MonitorPost.field_light;
//Code to post to the web server
  
   if (client.connect(server, 80)) {
    Serial.println("connecting to server");
    // send the HTTP PUT request:
    client.print("GET ");
    client.print(DRUPAL_URI_POND_MONITOR);
    client.print("?q=arduino/post&");
    client.print(data);
    client.println(" HTTP/1.1");
    client.print("Host: ");
    client.println(DRUPAL_SITE_POND_MONITOR);
    client.println("User-Agent: arduino-ethernet");
    client.println("Connection: close");
    client.println();
    client.stop();
    //Code to putput HTTP request to Serial for debugging.
    Serial.print("GET ");
    Serial.print(DRUPAL_URI_POND_MONITOR);
    Serial.print("?q=arduino/post&");
    Serial.print(data);
    Serial.println(" HTTP/1.1");
    Serial.print("Host: ");
    Serial.println(DRUPAL_SITE_POND_MONITOR);
    Serial.println("User-Agent: arduino-ethernet");
    Serial.println("Connection: close");
    Serial.println();


  } 
  else {
    // if you couldn't make a connection:
   Serial.println("connection failed");
    Serial.println("disconnecting.");
    client.stop();
  }
}
